var CometConnection = Class.create();
CometConnection.prototype = Object.extend(new Ajax.Request(), {
  initialize: function(url, canvas) {
    this.transport = Ajax.getTransport();
    this.canvas = canvas;
    this.setOptions();
    this.register();
    this.request(url);
  },
  onComplete: function() {
    new CometConnection(this.url, this.canvas);
  },
  onSuccess: function(transport, ary) {
    var start = new Date();
    var rowLength = ary.length;
    var colLength = ary[0].length;
    for (var x = 0; x < rowLength; x++) {
      for (var y = 0; y < colLength; y++) {
        var cell = this.canvas.find(x, y);
        if(cell){
          if(ary[x][y] == 1){
            cell.draw();
          }else {
            cell.erase();
          }
        }
      }
    }
  },
  evalJSON: function() {
    try {
      return eval('(' + this.transport.responseText + ')');
    } catch (e) {}
  },
  register: function() {
    for (var property in this) {
      var match = property.match(/^(on[A-Z].*)/);
      if(match) {
        this.options[match[1]] = this[match[1]].bind(this);
      };
    }
  }
});
